<!DOCTYPE html>
<html lang="en">
<head>
    <title>Nicholas Priambodo / 1606879905 / Kelas B</title>
    <meta charset="utf-8">

    <!-- Bootstrap 4-->
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js"></script>

    <!-- SockJS & StompJS -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/sockjs-client/1.1.4/sockjs.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/stomp.js/2.3.3/stomp.min.js"></script>
</head>
<body>

<div class="container-fluid">
    <h1 class="display-4 font-weight-bolder pt-3 text-center">Layanan & Aplikasi Web</h1>
    <h2 class="text-center font-weight-bolder">Assignment 3</h2>
    <h4 class="text-center">Nicholas Priambodo / 1606879905 / Kelas B</h4>

    <div class="row pt-5">
        <div class="col"></div>
        <div class="col jumbotron">

            <form>
                <div class="form-group text-center">
                  <label class="h4 font-weight-bolder pb-3" for="formControlFile">Upload & Compress File</label>
                  <div class="alert alert-danger" style="display: none;">
                    <strong>No file chosen!</strong> Please choose a file
                  </div>
                  <input type="file" class="form-control-file" id="formControlFile">
                </div>
            </form>
            <button onclick="upload()" id="upload-button" class="btn btn-primary btn-block">Upload</button>

            <div id="animation-uploading" class="pl-5 pt-3" style="display: none;">
                <div class="spinner-grow text-muted"></div>
                <div class="spinner-grow text-primary"></div>
                <div class="spinner-grow text-success"></div>
                <div class="spinner-grow text-info"></div>
                <div class="spinner-grow text-warning"></div>
                <div class="spinner-grow text-danger"></div>
                <div class="spinner-grow text-secondary"></div>
                <div class="spinner-grow text-dark"></div>
                <div class="spinner-grow text-light"></div>
            </div>

        </div>
        <div class="col"></div>
    </div>

    <div id="compression-progress" class="progress-bar progress-bar-striped progress-bar-animated bg-success"></div>

</div>
<script type="text/javascript">
    var x_routing_key = null;

    function upload() {
        if ($("#formControlFile").get(0).files.length === 0) {
            $('.alert').show(); 
        } else {
            $('.alert').hide(); 
            $("#upload-button").prop("disabled", true);
            $("#upload-button").text("Uploading...")
            $("#animation-uploading").show();
            $("#compression-progress").css("width", "0%");

            var form_data = new FormData();
            form_data.append(
                "file",
                $("#formControlFile").get(0).files[0]
            );

            $.ajax({
                type : "POST",
                enctype : "multipart/form-data",
                url : "{% url 'upload' %}",
                data : form_data,
                processData : false,
                contentType : false,
                cache : false,
                success : function(data, textStatus, xhr) {
                    $("#upload-button").text("Upload Succeed!")
                    $("#animation-uploading").hide();

                    x_routing_key = xhr.getResponseHeader("X-ROUTING-KEY");

                    getCompressionStatus();
                },
                error : function(e) {
                    $("#upload-button").prop("disabled", false);
                    $("#upload-button").text("Upload");
                    $("#animation-uploading").hide();
                    alert("Upload failed! " + e.responseText);
                }
            });
        }
    }

    function getCompressionStatus() {
        if ("WebSocket" in window) {
            var sockjs = new SockJS("{{rabbitmq_url}}");
            var stompjs = Stomp.over(sockjs);

            stompjs.connect(
                "{{username}}",
                "{{password}}",
                function() {
                    stompjs.subscribe(
                        "/{{type}}/{{npm}}/" + x_routing_key,
                        function(message) {
                            updateProgressBar(message.body);
                        }
                    );
                },
                function() {
                    console.log("Connection to Rabbitmq is closed!");
                },
                "{{vhost}}"
            );
        } else {
            alert("WebSocket NOT supported by your Browser!");
        }
    }

    function updateProgressBar(status) {
        if (status === "100%") {
            $("#compression-progress").text(status + " compression complete!");
            $("#upload-button").prop("disabled", false);
            $("#upload-button").text("Upload");
        } else {
            $("#compression-progress").text(status + " compressing");
        }

        $("#compression-progress").css("width", status);
    }
</script>
</body>
</html>
